#!/usr/bin/ruby
# coding: utf-8
require 'yaml'


# 注意:
#   以下の変数は, 下の別の箇所でもハードコーディングされている ('' で
#   囲まれたヒアドキュメント内に入っている) ため, ここで変更するだけでは
#   済まない.
#     正確には, file_htmltop, file_htmlbot はここで指定するだけでよいが.
file_htmlhead = "paramexp-cgi_htmlhead.txt"
file_htmltop  = "paramexp-cgi_htmltop.txt"
file_htmlbot  = "paramexp-cgi_htmlbot.txt"
file_cgitop   = "paramexp-cgi_cgitop.txt"
file_cgibot   = "paramexp-cgi_cgibot.txt"
file_yaml     = "paramexp-cgi.yml"


def put_message( line )
  put_header
  print line, "\n"
  print "<br>"
  put_footer
end
def put_header( title_txt = "", head = "" )
#    Content-type: text/html; charset=utf-8
  print <<~EOD1
    <html lang="ja">
    <head>
      <meta charset="utf-8">
  EOD1
  print head
  print "\n"
  print <<~EOD2
      <title>
  EOD2
  print title_txt
  print <<~EOD3
      </title>
    </head>
    <body onload="show_hide_parameter( )">
  EOD3
end
def put_footer
  print <<~EOD
    <script language="JavaScript">
      <!--

        function show_hide_parameter( )
        {

          // debug
          console.log( "In show_hide_parameter" );

          var obj_paramaxisx = document.getElementById( "id_select_param_axisx" );
          var obj_paramaxisy = document.getElementById( "id_select_param_axisy" );

          // チェック用パラメータリスト
          var obj_param_list = obj_paramaxisx

          // debug
          // パラメータの表示
          console.log( "  param list length : " + obj_param_list.options.length );
          for (let i = 0; i < obj_param_list.options.length; i++) {
                console.log( "    " + i + " : " + obj_param_list.options[i].value );
          }

          var idx              = obj_paramaxisx.selectedIndex;
          var paramaxisx_value = obj_paramaxisx.options[idx].value; // 値
          var idx              = obj_paramaxisy.selectedIndex;
          var paramaxisy_value = obj_paramaxisy.options[idx].value; // 値

          // debug
          // パラメータの display set to "none" or ""
          console.log( "  param list length : " + obj_param_list.options.length );
          var num_show = 0

          for (let i = 0; i < obj_param_list.options.length; i++) {
            // debug
            console.log( "    " + i + " : " + obj_param_list.options[i].value );

            //var id  = "id_select_" + obj_param_list.options[i].value
            var id  = "id_tr_" + obj_param_list.options[i].value
            var obj = document.getElementById( id );

            // debug
            console.log( '      display status : ' + obj.style.display );

            // "VARIABLES" の値を指定する必要はない.
            if ( obj_param_list.options[i].value == "VARIABLES" )
            {
              obj.style.display = "none"
            } else {
              // Only some of parameters are shown, if number of parameters is
              // greater than 2.
              if (    ( obj_param_list.options[i].value == paramaxisx_value )
                   || ( obj_param_list.options[i].value == paramaxisy_value ) )
              {
                obj.style.display = "none"
              } else {
                // obj.style.display = "block"
                obj.style.display = ""
                num_show++;
              }
            }

            // debug
            console.log( '      display status : ' + obj.style.display );

            var id  = "id_parameter_other_than_axies"
            var obj = document.getElementById( id );
            if ( num_show == 0 )
            {
              // All parameters are not shown.
              obj.style.display = "none"
            } else {
              obj.style.display = ""
            }

         }

          // 物理量の display set to "none" or ""
          var idx              = obj_paramaxisx.selectedIndex;
          var paramaxisx_value = obj_paramaxisx.options[idx].value; // 値
          var idx              = obj_paramaxisy.selectedIndex;
          var paramaxisy_value = obj_paramaxisy.options[idx].value; // 値

          var id  = "id_variable"
          var obj = document.getElementById( id );

          // debug
          console.log( '  物理量' );
          console.log( '    display status : ' + obj.style.display );
          if ( ( paramaxisx_value == "VARIABLES" ) || ( paramaxisy_value == "VARIABLES" ) )
          {
            obj.style.display = "none"
          } else {
            obj.style.display = ""
          }
          // debug
          console.log( '    display status : ' + obj.style.display );

        }

      -->
    </script>

    </body>
    </html>
  EOD
end

# This is an unnecessary line. This is written to change a style on emacs.
#</


yml_input = YAML.load_file( file_yaml )

nparams = yml_input["parameters"].size
if nparams < 2 then
  STDERR.print "Error: Number of parameters has to be 2 or larger.\n"
  exit
end

file_cgi = yml_input["file_cgi"]


if yml_input.key?(:html_titletxt) then
  html_titletxt = ""
else
  html_titletxt = yml_input["html_titletxt"]
end

if File.exist?( file_htmlhead ) then
  f = File.open( file_htmlhead, "r" )
  html_head = f.read  # 全て読み込む
  f.close
else
  html_head = ""
end

put_header( html_titletxt, html_head )

if File.exist?( file_htmltop ) then
  f = File.open( file_htmltop, "r" )
  lines = f.read  # 全て読み込む
  f.close
  print lines
end

print '  <div style="margin-left:2em">'

print "    <form method=get action=", file_cgi, ">"
print "\n"

nvars = yml_input["file_figs"].size
vars  = yml_input["file_figs"].keys
#
print '       <div id="id_variable">'
print "       物理量 :", "\n"
print '       <select name="variable">'
print "\n", "<br>", "\n"
for ivar in 0..(nvars-1)
  var       = vars[ivar]
  long_name = yml_input["file_figs"][var]
  if long_name == nil then
    long_name = var
  end
  if ivar == 0 then
    print '         <option value="', var, '" selected>'
  else
    print '         <option value="', var, '">'
  end
  print "           ", long_name
  print "         </option>"
  print "\n"
end
print '       </select>'
print "\n", "<br>", "\n"

print "\n", "<br>", "\n"
print '       </div>'


#print "\n", "<br>", "\n"

#################################################
# パラメータ軸
#################################################

nparams         = yml_input["parameters"].size
params          = yml_input["parameters"].keys
params_selected = yml_input["parameters_selected"]
if params_selected.is_a?(Array) then
  if params_selected.size == 1 then
    if params_selected[0] == params[0] then
      params_selected << params[1]
    else
      params_selected << params[0]
    end
  end
else
  params_selected = [params[0], params[1]]
end
#
print "       パラメータ軸 :"
print '       <p style="margin-left:2em; margin-top:0em">'
print "       <table>", "\n"
#
print "       <tr>"
print "         <td>横軸</td><td>:</td>"
print "         <td>"
print '           <select name="param_axisx" id="id_select_param_axisx" onchange="show_hide_parameter( )">'
print "\n", "<br>", "\n"
for iparam in 0..(nparams-1)
  param = params[iparam]

  nhash     = yml_input["parameters"][param].size
  long_name = yml_input["parameters"][param]["long_name"]
  if long_name == nil then
    long_name = param
  end
  values    = yml_input["parameters"][param]["values"]
  unit      = yml_input["parameters"][param]["unit"]

  if params_selected[0] == param then
    print '<option value= "', param, '" selected>', long_name, '</option>'
  else
    print '<option value= "', param, '"         >', long_name, '</option>'
  end
end
print '           </select>'
print "         </td>"
print "       </tr>"
print "\n"
#
print "       <tr>"
print "         <td>縦軸</td><td>:</td>"
print "         <td>"
print '           <select name="param_axisy" id="id_select_param_axisy" onchange="show_hide_parameter( )">'
for iparam in 0..(nparams-1)
  param = params[iparam]

  nhash     = yml_input["parameters"][param].size
  long_name = yml_input["parameters"][param]["long_name"]
  if long_name == nil then
    long_name = param
  end
  values    = yml_input["parameters"][param]["values"]
  unit      = yml_input["parameters"][param]["unit"]

  if params_selected[1] == param then
    print '<option value= "', param, '" selected>', long_name, '</option>'
  else
    print '<option value= "', param, '"         >', long_name, '</option>'
  end
end
print '           </select>'
print "         </td>"
print "       </tr>"
print "       </table>", "\n"
print '       </p>', "\n"

#print "\n", "<br>", "\n"
#print "\n", "<br>", "\n"


#################################################
# パラメータ軸以外のパラメータ
#################################################

nparams = yml_input["parameters"].size
params  = yml_input["parameters"].keys
#
print '       <div id="id_parameter_other_than_axies">'
print "       パラメータ軸以外のパラメータ :", "\n"
print '       <p style="margin-left:2em; margin-top:0em">', "\n"
print "       <table>", "\n"
for iparam in 0..(nparams-1)
  param = params[iparam]

  nhash     = yml_input["parameters"][param].size
  default   = yml_input["parameters"][param]["default"]
  long_name = yml_input["parameters"][param]["long_name"]
  if long_name == nil then
    long_name = param
  end
  values    = yml_input["parameters"][param]["values"]
  unit      = yml_input["parameters"][param]["unit"]

  print '       <tr id="id_tr_' + param + '">', "\n"
  print '         <td>', "\n"
  print "           ", long_name, "\n"
  print '         </td>', "\n"
  print '         <td>', "\n"
  print "           ", " : ", "\n"
  print '         </td>', "\n"
  print '         <td>', "\n"
  print '           <select name="', param, '">'
  for ival in 0..(values.size-1)
    value = values[ival].to_s
    if value == default.to_s then
      print '          <option value= "', value, '" selected>', value, '</option>'
    else
      print '          <option value= "', value, '"         >', value, '</option>'
    end
    print "\n"
  end
  print '           </select>'
  print "     ", " ", unit, "\n"
  print '         </td>', "\n"
  print '       </tr>', "\n"
  print "\n"
end
print "       </table>", "\n"
print '       </p>'
print '       </div>'


#################################################
# 各図の幅
#################################################

if yml_input.key?("fig_width") then
  fig_width = yml_input["fig_width"]
else
  fig_width = 250
end
#
print "       各図の幅 :"
#print "\n", "<br>", "\n"
#print "       &nbsp;"
#print "       &nbsp;"
print '       <input type="text" size=6 maxlength=6 name="fig_width" value=', fig_width, '>'
print " pixels", "\n"

print "\n", "<br>", "\n"
print "\n", "<br>", "\n"

print '      <input type=submit value="submit">'
print "\n", "<br>", "\n"

print "    </form>"
print '  </div>'


if File.exist?( file_htmlbot ) then
  f = File.open( file_htmlbot, "r" )
  lines = f.read  # 全て読み込む
  f.close
  print lines
end

put_footer


#########################################################
# cgi file
#########################################################

cgi_file_content = <<~'EOF'
#!/usr/bin/ruby
# coding: utf-8
require "cgi"
require 'yaml'

file_yaml   = "paramexp-cgi.yml"
file_cgitop = "paramexp-cgi_cgitop.txt"
file_cgibot = "paramexp-cgi_cgibot.txt"

def put_message( line )
  put_header
  print line, "\n"
  print "<br>"
  put_footer
end
def put_header
  print <<~EOD
  Content-type: text/html; charset=utf-8

  <html lang="ja">
  <head>
    <meta charset="utf-8">
    <!--
    <meta http-equiv="cache-control" content="private">
    -->
    <title>Parameter experiments</title>
  </head>
  <body>
  EOD
end
def put_footer
  print <<~EOD
    </body>
    </html>
  EOD
end

yml_input = YAML.load_file( file_yaml )

flag_debug     = yml_input["flag_debug"]
flag_show_info = yml_input["flag_show_info"]
flag_dirlink   = yml_input["flag_dirlink"]


pardir  = yml_input["pardir"]


params_name          = yml_input["parameters"].keys

#params_name          = ["RotPeriod", "Obl", "Radius"]
#param_rotperiod_val  = [1, 3, 10, 30, 90]
#param_rotperiod_unit = "Earth days"
#param_obl_val        = [0.0, 23.4, 60.0, 90.0]
#param_obl_unit       = "degrees"
#param_radius_val     = [6371, 4247, 3186]
#param_radius_unit    = "km"


in_hash = CGI.new


fixed_params_val = Array.new( params_name.size )
for i in 0..(params_name.size-1)
  fixed_params_val[i] = in_hash[ params_name[i] ]
end



file_fig         = in_hash[ "variable" ]
param_axisx_name = in_hash[ "param_axisx" ]
param_axisy_name = in_hash[ "param_axisy" ]
fig_width        = in_hash[ "fig_width" ]

if param_axisx_name == param_axisy_name then
  put_header
  print "Error: axisx has to be different from axisy."
  put_footer
  print "<br>"
  exit
end

param_axisx_long_name = yml_input["parameters"][param_axisx_name]["long_name"]
param_axisx_unit      = yml_input["parameters"][param_axisx_name]["unit"]
param_axisx_vals      = yml_input["parameters"][param_axisx_name]["values"]
param_axisx_format    = yml_input["parameters"][param_axisx_name]["label_format"]
#
param_axisy_long_name = yml_input["parameters"][param_axisy_name]["long_name"]
param_axisy_unit      = yml_input["parameters"][param_axisy_name]["unit"]
param_axisy_vals      = yml_input["parameters"][param_axisy_name]["values"]
param_axisy_format    = yml_input["parameters"][param_axisy_name]["label_format"]


#put_header
#for i in 0..(params_name.size-1)
#  print params_name[i], ":", fixed_params_val[i], "\n"
#  print "<br>"
#end
#print param_axisx_name, ":", param_axisx_vals, "\n"
#print "<br>"
#print param_axisy_name, ":", param_axisy_vals, "\n"
#print "<br>"
#put_footer
#exit


# file path
fixed_param_strings = Array.new( params_name.size )
for i in 0..(params_name.size-1)
  name         = params_name[i]
  label_format = yml_input["parameters"][name]["label_format"]
  label        = sprintf( label_format, fixed_params_val[i] )
  fixed_param_strings[i] = name + label
end


if false then
nx = param_axisx_vals.size
ny = param_axisy_vals.size
fig_paths = Array.new( ny ).map{ Array.new( nx ) }
param_strings = Array.new( params_name.size )
param_strings = fixed_param_strings
for j in 0..(param_axisy_vals.size-1)
  label = sprintf( param_axisy_format, param_axisy_vals[j] )
  param_axisy_string = param_axisy_name + label
  for k in 0..(params_name.size-1)
    if params_name[k] == param_axisy_name then
      param_strings[k] = param_axisy_string
    end
  end

  for i in 0..(param_axisx_vals.size-1)
    label = sprintf( param_axisx_format, param_axisx_vals[i] )
    param_axisx_string = param_axisx_name + label
    for k in 0..(params_name.size-1)
      if params_name[k] == param_axisx_name then
        param_strings[k] = param_axisx_string
      end
    end

    string = ""
    for k in 0..(params_name.size-1)
      string += "/" + param_strings[k]
    end

    dir = pardir + string
    fig_path = dir + "/" + file_fig
    fig_paths[j][i] = fig_path
  end
end

end

#########################
nvars = yml_input["file_figs"].size
vars  = yml_input["file_figs"].keys
if param_axisx_name == "VARIABLES" then
  # パラメータ軸が "VARIABLES" のとき, 軸の長さは変数 (ファイル) の数となる
  NParamAxisX = nvars
else
  NParamAxisX = param_axisx_vals.size
end
if param_axisy_name == "VARIABLES" then
  # パラメータ軸が "VARIABLES" のとき, 軸の長さは変数 (ファイル) の数となる
  NParamAxisY = nvars
else
  NParamAxisY = param_axisy_vals.size
end
fig_paths = Array.new( NParamAxisY ).map{ Array.new( NParamAxisX ) }

dir = pardir
for k in 0..(params_name.size-1)
  if params_name[k] != "VARIABLES" then
    # パラメータ軸, "VARIABLES", に対応する図のディレクトリは存在しない
    dir += "/" + fixed_param_strings[k]
  end
end

dir_org = dir
for j in 0..(NParamAxisY-1)
  label = sprintf( param_axisy_format, param_axisy_vals[j] )
  param_axisy_string = param_axisy_name + label

  for i in 0..(NParamAxisX-1)
    label = sprintf( param_axisx_format, param_axisx_vals[i] )
    param_axisx_string = param_axisx_name + label

    dir = dir_org
    if param_axisy_name != "VARIABLES" then
      # パラメータ軸, "VARIABLES", に対応する図のディレクトリは存在しない
      for k in 0..(params_name.size-1)
        if params_name[k] == param_axisy_name then
          dir = dir.sub( fixed_param_strings[k], param_axisy_string )
        end
      end
    end
    if param_axisx_name != "VARIABLES" then
      # パラメータ軸, "VARIABLES", に対応する図のディレクトリは存在しない
      for k in 0..(params_name.size-1)
        if params_name[k] == param_axisx_name then
          dir = dir.sub( fixed_param_strings[k], param_axisx_string )
        end
      end
    end

    fig_paths[j][i] = dir
  end
end
for j in 0..(NParamAxisY-1)
  for i in 0..(NParamAxisX-1)
    file_fig_local = file_fig
    if param_axisy_name == "VARIABLES" then
      # パラメータ軸に "VARIABLES" が選択された時, ファイル名を変更
      file_fig_local = vars[j]
    end
    if param_axisx_name == "VARIABLES" then
      # パラメータ軸に "VARIABLES" が選択された時, ファイル名を変更
      file_fig_local = vars[i]
    end
    fig_paths[j][i] += "/" + file_fig_local
  end
end
#########################


put_header

#print "This is a test page for cgi.", "\n"


#print "Figure path:", "<br>", "\n"
#for j in 0..(fig_paths[0].size-1)
#  for i in 0..(fig_paths.size-1)
#    print "  [", i, "][", j, "] ", fig_paths[j][i], "\n"
#    print "<br>", "\n"
#  end
#end


if File.exist?( file_cgitop ) then
  f = File.open( file_cgitop, "r" )
  lines = f.read  # 全て読み込む
  f.close
  print lines
end

print "<table border=1>", "\n"

# param values
#print "  <td rowspan=", NParamAxisY, ">", "\n"
#print "    ", param_axisy_name, "\n"
#print "  </td>", "\n"

#   1st line
print "<tr>", "\n"
print "  <td colspan=2 rowspan=2>", "\n"
print "  </td>", "\n"
#print "  <td>", "\n"
#print "  </td>", "\n"
print '  <td colspan=', NParamAxisX, ' align=center>', "\n"
if param_axisx_unit == "" then
  print "    ", param_axisx_long_name, "<br>", "\n"
else
  print "    ", param_axisx_long_name, "<br>", "(", param_axisx_unit, ")", "\n"
end
print "  </td>", "\n"
print "</tr>", "\n"
#   2nd line
print "<tr>", "\n"
#print "  <td>", "\n"
#print "  </td>", "\n"
#print "  <td>", "\n"
#print "  </td>", "\n"
for i in 0..(NParamAxisX-1)
  print "  <td align=center>", "\n"
  if param_axisx_name == "VARIABLES" then
#    print "    ", yml_input["file_figs"].keys[i], "\n"
    print "    ", yml_input["file_figs"][yml_input["file_figs"].keys[i]], "\n"
  else
    print "    ", param_axisx_vals[i], "\n"
  end
  print "  </td>", "\n"
end
print "</tr>", "\n"

#   3rd, 4th, ... lines
for j in 0..(NParamAxisY-1)

  print "<tr>", "\n"

  if j == 0 then
    print "  <td rowspan=", NParamAxisY, " align=center>", "\n"
    if param_axisy_unit == "" then
      print "    ", param_axisy_long_name, "<br>", "\n"
    else
      print "    ", param_axisy_long_name, "<br>", "(", param_axisy_unit, ")", "\n"
    end
    print "  </td>", "\n"
  end

  print "  <td align=center>", "\n"
  if param_axisy_name == "VARIABLES" then
#    print "    ", yml_input["file_figs"].keys[j], "\n"
    print "    ", yml_input["file_figs"][yml_input["file_figs"].keys[j]], "\n"
  else
    print "    ", param_axisy_vals[j], "\n"
  end
  print "  </td>", "\n"

  for i in 0..(NParamAxisX-1)

    fig_path = fig_paths[j][i]

    print '  <td align="center">', "\n"
    if File.exist?(fig_path) then
      if File.extname(fig_path) == ".mp4" then
        print '    <video controls src="', fig_path, '" width=', fig_width, '></video>', "\n"
      else
        print '    <img src="', fig_path, '" width=', fig_width, 'alt="" title="">', "\n"
      end
      if flag_dirlink then
        print "<br>"
        print "\n"
        print '    <a href="', fig_path[0..fig_path.rindex("/")-1], '">[directory]</a>', "\n"
        print "\n"
      end
    else
      print '    No figure', "\n"
    end
    # debug
    if flag_debug then
      print '    ', fig_path, "\n"
    end
    #
    print '  </td>', "\n"
  end
  print "</tr>", "\n"

end

print "</table>", "\n"


if flag_show_info then

  print "<br>", "\n"
  print "<br>", "\n"

  #print "=======================", "\n"
  #print "<br>", "\n"
  print "<hr>", "\n"

  print "Figure file : ", file_fig, "\n"
  print "<br>", "\n"

  print "<br>", "\n"

  for i in 0..(params_name.size-1)
    print "Parameter ", i, " : ", params_name[i], "=", fixed_params_val[i], "\n"
    print "<br>", "\n"
  end

  print "<br>", "\n"

  print "Column : ", param_axisx_name, "\n"
  print "<br>", "\n"
  print "Row    : ", param_axisy_name, "\n"
  print "<br>", "\n"

  print "<br>", "\n"

  print "Figure width : ", fig_width, "\n"
  print "<br>", "\n"

  #print "=======================", "\n"
  #print "<br>", "\n"
  print "<hr>", "\n"

end

if File.exist?( file_cgibot ) then
  f = File.open( file_cgibot, "r" )
  lines = f.read  # 全て読み込む
  f.close
  print lines
end

put_footer

EOF

f = File.open( file_cgi, "w" )
f.puts cgi_file_content
f.close
File.chmod( 0755, file_cgi )
